#include "krige_tiles.h"

void krige_tiles(double *xsw,
		double *ysw,
		double *xne,
		double *yne,
		double *angle,
		int *nx,
		int *ny,                 
		int *ntx,
		int *nty,
		double *dx,
		double *dy,
		int *itx,
		int *ity,
		double *xg,
		double *yg,
		double *zg,
		double *varg,
		int *dog,
		double *lon,
		double *lat,
		double *z,
		int *extrap,
		int *n,
		int *covtype,
		double *covpar,
		int *trend,
		int *ntrend,
		double *rsearch,
		int *nsearch,
		int *nsmin,
		int *nsmax,
		int *mode,
            int *bits,
	    int *ierr){

    int nz=(*nx)*(*ny), ldcov=(*n), ldc0=(*n), extcov=0,
	ldfwrk=(*n), ldlmbd=(*n), nkwork=(*n)+(*ntrend), nt=(*ntx)*(*nty), 
	ipt=(*itx)*(*ity);
    double *covmat, *c0vec, *fwork, *f0work, *dist, *kwork,
	   *rhswork, *mu, *lambda, cov0, *xgwork, *ygwork, *x0, *y0, *z0, 
	   *var0;
    int *indsnb, *indsna, *indsrt, *ipiv, *do0, *inddo;

#ifndef TRANSIENT
    covmat=Calloc((size_t)(*n)*(*n),double);
/*    c0vec=Calloc((size_t)(*n),double);    
    fwork=Calloc((size_t)(*n)*(*ntrend),double);    
    f0work=Calloc((size_t)(*ntrend),double);    
    dist=Calloc((size_t)(*n),double);    
    indsnb=Calloc((size_t)(*n),int);    
    indsna=Calloc((size_t)(*n),int);    
    indsrt=Calloc((size_t)(*n),int); 
    kwork=Calloc((size_t)(*n+*ntrend)*(*n+*ntrend),double); 
    rhswork=Calloc((size_t)(*n+*ntrend),double);
    ipiv=Calloc((size_t)(*n+*ntrend),int);
    mu=Calloc((size_t)(*ntrend),double);
    lambda=Calloc((size_t)(*n),double); 
    xgwork=Calloc((size_t)(nz),double);
    ygwork=Calloc((size_t)(nz),double); 
    x0=Calloc((size_t)(ipt),double); 
    y0=Calloc((size_t)(ipt),double); 
    z0=Calloc((size_t)(ipt),double); 
    do0=Calloc((size_t)(ipt),int); 
    inddo=Calloc((size_t)(ipt),int); 
    var0=Calloc((size_t)(ipt),double); */
   
#else
    covmat=(double *) R_alloc((*n)*(*n),sizeof(double));
    c0vec=(double *) R_alloc((*n),sizeof(double));
    fwork=(double *) R_alloc((*n)*(*ntrend),sizeof(double));    
    f0work=(double *) R_alloc((*ntrend),sizeof(double));    
    dist=(double *) R_alloc((*n),sizeof(double));
    indsnb=(int *) R_alloc((*n),sizeof(int));
    indsna=(int *) R_alloc((*n),sizeof(int));
    indsrt=(int *) R_alloc((*n),sizeof(int));
    kwork=(double *) R_alloc((*n+*ntrend)*(*n+*ntrend),sizeof(double)); 
    rhswork=(double *) R_alloc((*n+*ntrend),sizeof(double)); 
    ipiv=(int *) R_alloc((*n+*ntrend),sizeof(int)); 
    mu=(double *) R_alloc((*ntrend),sizeof(double));
    lambda=(double *) R_alloc((*n),sizeof(double));
    xgwork=(double *) R_alloc((nz),sizeof(double));
    ygwork=(double *) R_alloc((nz),sizeof(double)); 
    x0=(double *) R_alloc((ipt),sizeof(double)); 
    y0=(double *) R_alloc((ipt),sizeof(double)); 
    z0=(double *) R_alloc((ipt),sizeof(double)); 
    do0=(int *) R_alloc((ipt),sizeof(int)); 
    inddo=(int *) R_alloc((ipt),sizeof(int)); 
    var0=(double *) R_alloc((ipt),sizeof(double)); 
#endif

/*    
    F77_CALL(krgtil)(xsw, 
		     ysw, 
		     xne, 
		     yne, 
		     angle, 
		     nx, 
		     ny, 
		     &nz,
		     ntx,
		     nty,
		     &nt,
		     dx, 
		     dy,
		     itx,
		     ity,
		     &ipt,
		     xg, 
		     yg, 
		     zg, 
		     varg, 
		     dog,
		     xgwork,
		     ygwork,
		     lon, 
		     lat, 
		     z, 
		     extrap, 
		     n, 
		     covtype, 
		     covpar, 
		     covmat, 
		     &ldcov, 
		     c0vec, 
		     &ldc0, 
		     &cov0, 
		     &extcov, 
		     trend, 
		     ntrend, 
		     rsearch, 
		     nsearch, 
		     nsmin, 
		     nsmax, 
		     fwork, 
		     &ldfwrk, 
		     f0work, 
		     dist, 
		     indsnb, 
		     indsna, 
		     indsrt, 
		     kwork, 
		     &nkwork, 
		     rhswork, 
		     ipiv, 
		     mode, 
		     mu, 
		     lambda, 
		     &ldlmbd,
		     x0,
		     y0,
		     z0,
		     do0,
		     inddo,
		     var0,
		     bits, 
		     ierr);
*/    

#ifndef TRANSIENT
/*
    Free(var0);
    Free(inddo);
    Free(do0);
    Free(z0);
    Free(y0);
    Free(x0);
    Free(ygwork);
    Free(xgwork);
    Free(lambda);
    Free(mu);
    Free(ipiv);
    Free(rhswork);
    Free(kwork);
    Free(indsrt);
    Free(indsna);
    Free(indsnb);
    Free(dist);
    Free(f0work);
    Free(fwork);
    Free(c0vec);
*/
    Free(covmat);
#endif
}
    
